//-----------------------------------------------------------------------------
//  CpuRegHAL.h
/// @file
///
/// @brief Header for the module CpuRegHAL.c
///
/// This is the header for the module CpuRegHAL.c
///
/// @copyright 2013 Sirona Dental Systems GmbH - All Rights Reserved
///
/// @status  Draft
/// @date    $Date:$
/// @version $Revision$
/// @author  Eike Mueller(TABO)
///
/// @history
/// Date/Ver   Author/Modification
///
/// 2013-07-05 Eike Mueller(TABO)
///            Draft => V.1.0
/// @endhistory
//-----------------------------------------------------------------------------
#ifndef __CPUREGHAL_H
 #define __CPUREGHAL_H

//-----------------------------------------------------------------------------
// Standard include files
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Project specific include files
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Definitions ,makros and constants
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Datatypes
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Prototypes of public functions
//-----------------------------------------------------------------------------
// Reads the tickcountvalue 1 register of the PIT
UDWORD CRHal_GetCPUDeviceID();
//Reads the device id register of the cpu
void CRHal_GetCPUUniqueID (PUBYTE pBuffer);
// Reads the unique id register of the cpu
UDWORD CRHal_GetPITCounterVal();
// Enable the low power modes
void CRHal_EnableVeryLowPowerModes (void);

#endif //__CPUREGHAL_H
